<?php

namespace FiloBlu\DisableShop\Plugin\Magento\Catalog\Model;

use FiloBlu\DisableShop\Helper\Data;

/**
 * Class Config
 * @package FiloBlu\DisableShop\Plugin\Magento\Catalog\Model
 */
class Config
{

    /**
     * @var Data
     */
    protected $_helper;

    /**
     * Config constructor.
     * @param Data $helper
     */
    public function __construct(
        Data $helper
    ) {
        $this->_helper = $helper;
    }

    /**
     * @param $subject
     * @param $proceed
     * @return mixed
     */
    public function aroundGetAttributeUsedForSortByArray(
        $subject,
        $proceed
    ) {
        $result = $proceed();

        if ($this->_helper->canHidePrice()) {
            unset($result['price']);
        }

        return $result;
    }
}
