<?php

namespace FiloBlu\DisableShop\Plugin\Magento\Catalog\Model\Layer;

use Exception;
use FiloBlu\DisableShop\Helper\Data;
use Magento\Catalog\Model\Layer;

/**
 * Class FilterList
 * @package FiloBlu\DisableShop\Plugin\Magento\Catalog\Model\Layer
 */
class FilterList
{
    /**
     * @var Data
     */
    protected $_helper;

    /**
     * FilterList constructor.
     * @param Data $helper
     */
    public function __construct(
        Data $helper
    ) {
        $this->_helper = $helper;
    }

    /**
     * @param $subject
     * @param $proceed
     * @param Layer $layer
     * @return mixed
     */
    public function aroundGetFilters(
        $subject,
        $proceed,
        Layer $layer
    ) {
        $result = $proceed($layer);

        if ($this->_helper->canHidePrice()) {
            $_indexFilterToRemove = null;
            $_currentIndex = -1;

            foreach ($result as $filter) {
                $_currentIndex++;
                try {
                    if ($filter->getAttributeModel()->getAttributeCode() === 'price') {
                        $_indexFilterToRemove = $_currentIndex;
                    }
                } catch (Exception $ex) {
                }
            }

            if ($_indexFilterToRemove) {
                unset($result[$_indexFilterToRemove]);
            }
        }

        return $result;
    }
}
